mod Ul03

incl Mtex

incl Mtexpl

incl Maux

loc rem 
  \para \bf  PREMIOVA ULOHA Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE 
   \end 

rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end utorok 16.5.2006 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/0506ls/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

rem 
  \para* \it  Termin:  \end Premiovu ulohu odovzdajte najneskor v pondelok 
  29.5.2006 do 18:00. 
  \para* \it  Format:  \end Subor \it  ul03.cl  \end ako priloha v elektronickej 
  poste. 
  \para* \it  Hodnotenie:  \end 
  \items 
   \item \para Pocet bodov za premiove ulohy: \it  3  \end. 
   \item \para Ulohy rieste \bf  samostatne!  \end 
  \end

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Symbolic Expressions.  \end 

rem 
  \para \bf  Section. Propositional Logic.  \end 

rem 
  \para \bf  Exercise.  \end \it  [Premiova uloha (3 body)]  \end 
  \header* fun Dprf 'Tex_f1_f' \end Define the function \ft Dprf(a) \end such 
  that 
  \eq* 
    Form(a) & v in Dprf(a) -> ~True(v,a)
  \end
  \eq* 
    Form(a) & ~Taut(a) -> Dprf(a) != 0
  \end
  \para Note that we then have 
  \eq* 
    Form(a) -> \a v(v in Dprf(a) -> ~True(v,a))
  \end
  \eq* 
    Form(a) -> Taut(a) <-> Dprf(a) = 0
  \end
  \eq* 
    Form(a) -> ~Taut(a) <-> Dprf(a) != 0
  \end

fun Dprf 'Tex_p1_pl_prf'
  Dprf(a) = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

rem 
  \para The following formulas are tautologies: 

loc fun/0 A1 
  A1 = Imp(Pvar(1),Imp(Pvar(2),Pvar(1)))

loc fun/0 A2 
  A2 = Imp(And(Imp(Pvar(1),Pvar(2)),Imp(Pvar(2),Pvar(3))),Imp(Pvar(1),Pvar(3)))

loc fun/0 A3 
  A3 = 
  Imp(And(And(Imp(Pvar(1),Pvar(3)),Imp(Pvar(2),Pvar(3))),Or(Pvar(1),Pvar(2))),
      Pvar(3))

loc fun/0 A4 
  A4 = Iff(Not Imp(Pvar(1),Pvar(2)),And(Pvar(1),Not Pvar(2)))

loc fun/0 A5 
  A5 = 
  Iff(Or(Pvar(1),And(Pvar(2),Pvar(3))),
      And(Or(Pvar(1),Pvar(2)),Or(Pvar(1),Pvar(3))))

loc rem 
  \para and the following are not: 

loc fun/0 B1 
  B1 = 
  Imp(Imp(And(Pvar(1),Pvar(2)),Pvar(3)),
      And(Imp(Pvar(1),Pvar(3)),Imp(Pvar(2),Pvar(3))))

loc fun/0 B2 
  B2 = Imp(Or(Pvar(1),Pvar(2)),And(Pvar(1),Pvar(2)))

loc fun/0 B3 
  B3 = Imp(Imp(Pvar(1),Pvar(2)),Imp(Not Pvar(1),Not Pvar(2)))

